LFGTimer = LibStub("AceAddon-3.0"):NewAddon("LFGTimer", "AceEvent-3.0");
local addon = LFGTimer; -- upvalue the addon table
local L = LibStub("AceLocale-3.0"):GetLocale("LFGTimer", true);

addon.Hooks = {
	{"JoinLFG", function() addon:LFGStart() end},
--	{"LeaveLFG", function() addon:LFGStop() end},
	{"LFDSearchStatus_Update", function() addon:StatusUpdate() end},
};

function addon:OnInitialize()
	self:SetupHooks();
	self:LetsDoSomeHackery();
end

function addon:OnProfileChanged(event, database, newProfileKey)
	db = database.profile;
end

function addon:SetupHooks()
	for i, v in ipairs(self.Hooks) do
		hooksecurefunc(unpack(v));
	end
end

function addon:LFGStart()
	self.lfg_start_time = GetTime();
end

function addon:LFGStop()
end

function addon:StatusUpdate()
	local lfgData = {GetLFGQueueStats()};
	if not lfgData[1] then
		return;
	end
	local myWait = lfgData[12];
	local text = string.format(LFG_STATISTIC_AVERAGE_WAIT .. "\n" .. L["Time in queue: %s"], myWait == -1 and TIME_UNKNOWN or SecondsToTime(myWait, false, false, 1), SecondsToTime(GetTime() - self.lfg_start_time, false, false, 1));
	LFDSearchStatus.statistic:SetText(text);
end

function addon:LetsDoSomeHackery()
	--[[
		Blizzard, in its ultimate brilliance made <OnShow function="LFDSearchStatus_Update"/> resolve at 'compile' time (when the file is read and parsed, etc).
		This isn't a bad idea, except in this case.
		For the purpose of this addon, we are adding a small bit of text to the Looking for Dungeon search status window. Since the function address was resolved at complile time, our hooksecurefunc call does not properly redirect this call with the hooked version. Thus everytime the window is shown, all our hard work to change the little bit of text is reset.
		FUCKING YAY!
		Hackery inc.
	--]]
	LFDSearchStatus:SetScript("OnShow", LFDSearchStatus_Update); -- lets make it follow the right execution path
	LFDSearchStatus:SetScript("OnUpdate", function() addon:StatusUpdate(); end); -- just so we can see the seconds clock up. in frustration, of course
	-- add any other Blizzard fuck up work arounds here
end
